<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Follower.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">Follower.java</span></div><h1>Follower.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.InetSocketAddress;

import org.apache.jute.BinaryInputArchive;
import org.apache.jute.Record;
import org.apache.zookeeper.server.util.SerializeUtils;
import org.apache.zookeeper.server.util.ZxidUtils;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * This class has the control logic for the Follower.
 */
public class Follower extends Learner{

    private long lastQueued;
    // This is the same object as this.zk, but we cache the downcast op
    final FollowerZooKeeperServer fzk;
    
<span class="fc" id="L40">    Follower(QuorumPeer self,FollowerZooKeeperServer zk) {</span>
<span class="fc" id="L41">        this.self = self;</span>
<span class="fc" id="L42">        this.zk=zk;</span>
<span class="fc" id="L43">        this.fzk = zk;</span>
<span class="fc" id="L44">    }</span>

    @Override
    public String toString() {
<span class="nc" id="L48">        StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L49">        sb.append(&quot;Follower &quot;).append(sock);</span>
<span class="nc" id="L50">        sb.append(&quot; lastQueuedZxid:&quot;).append(lastQueued);</span>
<span class="nc" id="L51">        sb.append(&quot; pendingRevalidationCount:&quot;)</span>
<span class="nc" id="L52">            .append(pendingRevalidations.size());</span>
<span class="nc" id="L53">        return sb.toString();</span>
    }

    /**
     * the main method called by the follower to follow the leader
     *
     * @throws InterruptedException
     */
    void followLeader() throws InterruptedException {
<span class="fc" id="L62">        self.end_fle = System.currentTimeMillis();</span>
<span class="fc" id="L63">        LOG.info(&quot;FOLLOWING - LEADER ELECTION TOOK - &quot; +</span>
              (self.end_fle - self.start_fle));
<span class="fc" id="L65">        self.start_fle = 0;</span>
<span class="fc" id="L66">        self.end_fle = 0;</span>
<span class="fc" id="L67">        fzk.registerJMX(new FollowerBean(this, zk), self.jmxLocalPeerBean);</span>
        try {
<span class="fc" id="L69">            InetSocketAddress addr = findLeader();            </span>
            try {
<span class="fc" id="L71">                connectToLeader(addr);</span>
<span class="fc" id="L72">                long newEpochZxid = registerWithLeader(Leader.FOLLOWERINFO);</span>

                //check to see if the leader zxid is lower than ours
                //this should never happen but is just a safety check
<span class="fc" id="L76">                long newEpoch = ZxidUtils.getEpochFromZxid(newEpochZxid);</span>
<span class="pc bpc" id="L77" title="1 of 2 branches missed.">                if (newEpoch &lt; self.getAcceptedEpoch()) {</span>
<span class="nc" id="L78">                    LOG.error(&quot;Proposed leader epoch &quot; + ZxidUtils.zxidToString(newEpochZxid)</span>
<span class="nc" id="L79">                            + &quot; is less than our accepted epoch &quot; + ZxidUtils.zxidToString(self.getAcceptedEpoch()));</span>
<span class="nc" id="L80">                    throw new IOException(&quot;Error: Epoch of leader is lower&quot;);</span>
                }
<span class="fc" id="L82">                syncWithLeader(newEpochZxid);                </span>
<span class="fc" id="L83">                QuorumPacket qp = new QuorumPacket();</span>
<span class="fc bfc" id="L84" title="All 2 branches covered.">                while (self.isRunning()) {</span>
<span class="fc" id="L85">                    readPacket(qp);</span>
<span class="fc" id="L86">                    processPacket(qp);</span>
                }
<span class="fc" id="L88">            } catch (Exception e) {</span>
<span class="fc" id="L89">                LOG.warn(&quot;Exception when following the leader&quot;, e);</span>
                try {
<span class="fc" id="L91">                    sock.close();</span>
<span class="nc" id="L92">                } catch (IOException e1) {</span>
<span class="nc" id="L93">                    e1.printStackTrace();</span>
<span class="fc" id="L94">                }</span>
    
                // clear pending revalidations
<span class="fc" id="L97">                pendingRevalidations.clear();</span>
<span class="fc" id="L98">            }</span>
<span class="fc" id="L99">        } finally {</span>
<span class="nc" id="L100">            zk.unregisterJMX((Learner)this);</span>
<span class="fc" id="L101">        }</span>
<span class="pc" id="L102">    }</span>

    /**
     * Examine the packet received in qp and dispatch based on its contents.
     * @param qp
     * @throws IOException
     */
    protected void processPacket(QuorumPacket qp) throws IOException{
<span class="pc bpc" id="L110" title="2 of 7 branches missed.">        switch (qp.getType()) {</span>
        case Leader.PING:            
<span class="fc" id="L112">            ping(qp);            </span>
<span class="fc" id="L113">            break;</span>
        case Leader.PROPOSAL:            
<span class="fc" id="L115">            TxnHeader hdr = new TxnHeader();</span>
<span class="fc" id="L116">            Record txn = SerializeUtils.deserializeTxn(qp.getData(), hdr);</span>
<span class="fc bfc" id="L117" title="All 2 branches covered.">            if (hdr.getZxid() != lastQueued + 1) {</span>
<span class="fc" id="L118">                LOG.warn(&quot;Got zxid 0x&quot;</span>
<span class="fc" id="L119">                        + Long.toHexString(hdr.getZxid())</span>
                        + &quot; expected 0x&quot;
<span class="fc" id="L121">                        + Long.toHexString(lastQueued + 1));</span>
            }
<span class="fc" id="L123">            lastQueued = hdr.getZxid();</span>
<span class="fc" id="L124">            fzk.logRequest(hdr, txn);</span>
<span class="fc" id="L125">            break;</span>
        case Leader.COMMIT:
<span class="fc" id="L127">            fzk.commit(qp.getZxid());</span>
<span class="fc" id="L128">            break;</span>
        case Leader.UPTODATE:
<span class="nc" id="L130">            LOG.error(&quot;Received an UPTODATE message after Follower started&quot;);</span>
<span class="nc" id="L131">            break;</span>
        case Leader.REVALIDATE:
<span class="fc" id="L133">            revalidate(qp);</span>
<span class="fc" id="L134">            break;</span>
        case Leader.SYNC:
<span class="fc" id="L136">            fzk.sync();</span>
            break;
        }
<span class="fc" id="L139">    }</span>

    /**
     * The zxid of the last operation seen
     * @return zxid
     */
    public long getZxid() {
        try {
<span class="fc" id="L147">            synchronized (fzk) {</span>
<span class="fc" id="L148">                return fzk.getZxid();</span>
<span class="nc" id="L149">            }</span>
<span class="nc" id="L150">        } catch (NullPointerException e) {</span>
<span class="nc" id="L151">            LOG.warn(&quot;error getting zxid&quot;, e);</span>
        }
<span class="nc" id="L153">        return -1;</span>
    }
    
    /**
     * The zxid of the last operation queued
     * @return zxid
     */
    protected long getLastQueued() {
<span class="nc" id="L161">        return lastQueued;</span>
    }

    @Override
    public void shutdown() {    
<span class="fc" id="L166">        LOG.info(&quot;shutdown called&quot;, new Exception(&quot;shutdown Follower&quot;));</span>
<span class="fc" id="L167">        super.shutdown();</span>
<span class="fc" id="L168">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>